 //Релиз от 29,06,2019
// Секция начальных установок
#define resist_keyboard 1 //Раскоментировать, если клавиатура резистивная
 #define params_from_pc 1 //Раскоментировать, если нужно передавать параметры в РС
//#define no_pc 1;       //Раскоментировать, если вообще не надо связь с РС и закоментировать params_from_pc

#define SetAltPin        // Раскомментировать, если используются АЛЬТЕРНАТИВНЫЕ пины для подключения

// Секция СТАНДАРТНАЯ кнопок, пинов подключеня  --------------
#ifndef SetAltPin
  #define RelayPin1 7  //назначаем пин "ВЕРХНЕГО" нагревателя
  #define RelayPin2 6  //назначаем пин "НИЖНЕГО" нагревателя
  #define P1_PIN 9     //назначаем пин реле 1
  #define P2_PIN 10    //назначаем пин реле 2
  #define P3_PIN 11    //назначаем пин реле 3
  #define P4_PIN 12    //назначаем пин реле 4
  #define buzzerPin 8  // пин для буззера
  #define Knopki A0    // пин подключения аналоговой клавиатуры
  //назначаем пины усилителя термопары MAX6675 "ВЕРХНЕГО" нагревателя   clk=sck cs=cs do=so
  #define thermoCLK 17  //=sck
  #define thermoCS 18   //=cs
  #define thermoDO 19   //=so
  //назначаем пины усилителя термопары MAX6675 "НИЖНЕГО" нагревателя clk=sck cs=cs do=so
  #define thermoCLK2 14  //=sck
  #define thermoCS2 15   //=cs
  #define thermoDO2 16   //=so 
  
// Секция АЛЬТЕРНАТИВНАЯ кнопок, пинов подключеня ---------------------------
#else 
  #define RelayPin1 7  //назначаем пин "ВЕРХНЕГО" нагревателя
  #define RelayPin2 6  //назначаем пин "НИЖНЕГО" нагревателя
  #define P1_PIN 9     //назначаем пин реле 1
  #define P2_PIN 10    //назначаем пин реле 2
  #define P3_PIN 11    //назначаем пин реле 3
  #define P4_PIN 12    //назначаем пин реле 4
  #define buzzerPin 8  // пин для буззера
  #define Knopki A5    // пин подключения аналоговой клавиатуры
  //назначаем пины усилителя термопары MAX6675 "ВЕРХНЕГО" нагревателя   clk=sck cs=cs do=so
  #define thermoCLK 14  //=sck
  #define thermoCS 15   //=cs
  #define thermoDO 16   //=so
  //назначаем пины усилителя термопары MAX6675 "НИЖНЕГО" нагревателя clk=sck cs=cs do=so
  #define thermoCLK2 14  //=sck
  #define thermoCS2 17   //=cs
  #define thermoDO2 16   //=so
#endif
//------------------------------------------------------
// если детектор нуля не используется - закомментировать оба варианта
// и будет использоваться программный таймер (нужна библиотека MsTimer2.h)
// скачать по ссылке https://github.com/PaulStoffregen/MsTimer2
//
// назначение пина детектора нуля ZCC 
// #define SetInterrupt 0     // подключение к пину 2
// #define SetInterrupt 1     // подключение к пину 3
//------------------------------------------------------
// ожидаемые значения для псевдо-кнопок
#define SetRIGHT 144
#define SetUP 353
#define SetDOWN 711
#define SetLEFT 569
#define SetSELECT 4

//#define SetPicHeater    // Раскомментировать если нужна картинка на стартовом экране

// Используемые библиотеки -----------------------------
#include <EEPROM.h>
#include <UTFT.h>

#ifndef SetInterrupt
  #include <MsTimer2.h>  //
#endif
//Секция экрана-----------------------------------------
UTFT myGLCD(CTE40, 38, 39, 40, 41);
//UTFT myGLCD(CTE32HR, 38, 39, 40, 41);
extern uint8_t SmallFont[];
extern uint8_t BigFont[];
extern uint8_t BigFontRus[]; //Кирилица
extern uint8_t SevenSegNumFont[];
//------------------------------------------------------
#ifdef SetPicHeater
  extern unsigned int Heater2[0x1000];
#endif
//Секция ПИД----------------------------------------------
#define SENSOR_SAMPLING_TIME 250 //время чтения температуры и пересчёта ПИД(милисекунды)
#define i_min 0.0//минимум И составляющей
#define i_max 100.0//максимум И составляющей
// byte kp1, ki1, kd1;
// byte kp2, ki2, kd2;
byte Setpoint1;
byte Output1, Output2;
double Input1, Input2;
float integra, integra2;
float e1, p1,d1,e2,p2,d2;
int SP2;    // ?

//Секция графиков--------------------------------------------
int Xgr, XTgr=2; // x координата графика
byte Cgr,CTgr=0;
float Input_f1, Input_f2;

//секция алгоритма Брезенхема--------------------------------
int er1 = 1, er2 = 1;
int reg1, reg2;
boolean out1, out2;

// ----------------------------------------------------------
#ifdef resist_keyboard
          //#define A_PINS_BASE 100 // номер с которого начинается нумерация наших "псевдо-кнопок".
          #define PIN_RIGHT 100
          #define PIN_UP 101
          #define PIN_DOWN 102
          #define PIN_LEFT 103
          #define PIN_SELECT 104
 
          struct A_PIN_DESC{ // определяем  структуру которой будем описывать какое значение мы ожидаем для каждого псевдо-пина
             byte pinNo; // номер пина
             int expectedValue;// ожидаемое значение
          };
          A_PIN_DESC expected_values[]={ // ожидаемые значения для псевдо-кнопок
            { PIN_RIGHT,SetRIGHT},
            { PIN_UP,SetUP},
            { PIN_DOWN,SetDOWN},
            { PIN_LEFT,SetLEFT},
            { PIN_SELECT,SetSELECT}
          };
          #define A_PINS_COUNT sizeof(expected_values)/sizeof(A_PIN_DESC) // вычисляем сколько у нас всего "псевдо-кнопок" заданно.
          #define A_POSSIBLE_ABERRATION 50 // допустимое отклонение analogRead от ожидаемого значения, при котором псевдо кнопка считается нажатой
          bool digitalReadA(byte pinNo){
   
            for(byte i=0;i<A_PINS_COUNT;i++){ // ищем описание нашего всевдо-пина
              A_PIN_DESC pinDesc=expected_values[i];// берем очередное описание
                if(pinDesc.pinNo==pinNo){ // нашли описание пина?
                    int value=analogRead(Knopki); // производим чтение аналогово входа
                  return (abs(value-pinDesc.expectedValue)<A_POSSIBLE_ABERRATION); // возвращаем HIGH если отклонение от ожидаемого не больше чем на A_POSSIBLE_ABERRATION
               }
           }
           return LOW; // если не нашли описания - считаем что пин у нас LOW
          }
          //Назначаем пины кнопок управления
          byte upSwitchPin = PIN_UP;
          byte downSwitchPin = PIN_DOWN;
          byte cancelSwitchPin = PIN_LEFT;
          byte okSwitchPin = PIN_SELECT;
#endif

#ifndef resist_keyboard
byte upSwitchPin = 21;     //пин кнопки вверх
byte downSwitchPin = 20;   //пин кнопки вниз
byte cancelSwitchPin = 19; //пин кнопки отмена или назад
byte okSwitchPin = 18 ;    //пин кнопки ОК или подтверждения
#endif

//состояние кнопок по умолчанию
int upSwitchState = 0;
int downSwitchState = 0;
int cancelSwitchState = 0;
int okSwitchState = 0;

// переменные для кнопок
byte Hselect = 0;
long ms_button = 0;
boolean  button_state = false;
boolean  button_long_state = false;

// Секция профиля----------------------------------------------------------
#define numMax 5              // Максимальное количество профилей
#define ArrMax 50             // Максимальное количество символов в названии профиля (в русских буквах в два раза меньше)
#define Adres 2000            // адрес начала записи в EPROM 

struct pr {                   // основные поля профиля
  char HeadProf[ArrMax];      // заголовок профиля ArrMax символов
  byte tableSize;             // размер низа
  byte Setpoint2;             // температура низа в градусах
  byte BottomRampRateStep;    // скорость нагрева низа (увелчена в 10 раз)
  byte min_pwr_BOTTOM;        // минимальная мощность нижнего нагревателя
  byte max_pwr_BOTTOM;        // максимальная мощность нижнего нагревателя
  byte profileSteps;          // количество шагов профиля
  byte rampRateStep[3];       // скорость нагрева верхом по шагам (увелчена в 10 раз)
  byte temperatureStep[3];    // заданные температуры для шагов профиля ВИ
  byte dwellTimerStep[3];     // установленное время перехода на следующий шаг
  byte min_pwr_TOPStep[3];    // min мощности по шагам в % верхнего нагревателя
  byte max_pwr_TOPStep[3];    // max мощности по шагам в % верхнего нагревателя
  byte kp1;                   // коэф ПИД 1 верха
  byte ki1;
  byte kd1;
  byte kp2;                   // коэф ПИД 2 низа
  byte ki2;
  byte kd2;
};
byte SizeProfile = sizeof(pr); // длинна поля данных
pr profile;

String DuStr="";
byte currentProfile = 1;
byte currentStep = 1;
byte profileName;
byte editStep = 0;

//Секция флагов-----------------------------------------------------------
byte flag = 0;  //флаг для фиксации стартовой температуры
byte x=1;       //переменная для перехода на нужный шаг при горячей плате
boolean TopStart = false;
boolean alarmOn = false;
boolean updateScreen = true;

//Секция переменных общего назначения-------------------------------------
long previousMillis; //это для счетчиков
unsigned long nextRead1; //переменная для обновления текущей температуры
unsigned long currentMillis, prev_millis=0;
int startTemp;
int counter;
int tc1, tc2;
int i = 0;
byte setpointRamp, setpointRamp2;  // ?
byte Secs=0, bottomTemp, bottomMaxPwr;

//секция ввода/вывода для ПЭВМ-----------------------------------------------
#ifndef no_pc
char buf[20];   //буфер вывода сообщений через сом порт
#endif
#ifdef params_from_pc
char buf1[70];  //буфер вывода праметров через сом порт
String ttydata; //принятая строка параметров с сом порта от ПЭВМ
#endif
//---------------------------------------------------------------------------
typedef enum REFLOW_STATE:byte  {
  REFLOW_STATE_IDLE,
  REFLOW_STATE_MENU_STEPS,
  REFLOW_STATE_MENU_TABLE_SIZE,
  REFLOW_STATE_MENU_BOTTOM_HEAT,
  REFLOW_STATE_MENU_BOTTOM_PWR_MIN,
  REFLOW_STATE_MENU_BOTTOM_PWR_MAX,
  REFLOW_STATE_MENU_BOTTOM_RAMP,
  REFLOW_STATE_MENU_STEP_RAMP,
  REFLOW_STATE_MENU_STEP_TARGET,
  REFLOW_STATE_MENU_TOP_PWR_MIN,
  REFLOW_STATE_MENU_TOP_PWR_MAX,
  REFLOW_STATE_MENU_STEP_DWELL,
  REFLOW_STATE_MENU_BOTTOM_P,
  REFLOW_STATE_MENU_BOTTOM_I,
  REFLOW_STATE_MENU_BOTTOM_D,
  REFLOW_STATE_MENU_TOP_P,
  REFLOW_STATE_MENU_TOP_I,
  REFLOW_STATE_MENU_TOP_D,
  REFLOW_STATE_BOTTOM_STEP_RAMP,
  REFLOW_STATE_STEP_RAMP,
  REFLOW_STATE_TABLE_SIZE,
  REFLOW_STATE_STEP,
  REFLOW_STATE_STEP_DWELL,
  REFLOW_STATE_COMPLETE
}
reflowState_t;
//---------------------------------------------------------------------------
typedef enum REFLOW_STATUS:byte {  //this is simply to check if reflow should be running or not
  REFLOW_STATUS_OFF,
  REFLOW_STATUS_ON
}
reflowStatus_t;

reflowStatus_t reflowStatus;
reflowState_t reflowState;

void loadProfile()  {    // Загрузка профиля из EEPROM или из РС
    DuStr="";
    String DuVr; 
   for (byte j=0; j<=SizeProfile-1; j++) { 
       EEPROM.get(Adres+(currentProfile-1)*SizeProfile,profile);
   }
    DuVr = String(profile.HeadProf); 
    if (profile.HeadProf[1] == 255)  DuStr += "НЕИЗВЕСТНЫЙ ПРОФИЛЬ " + String(currentProfile)+" ";
      else {
       for (byte i=0; i<ArrMax; i++) {
         if (DuVr.substring(i, i+1) == "\0" || DuVr.substring(i, i+1) == "\n") {
          DuStr += DuVr.substring(0, i);
          DuStr += "\n";
          i=ArrMax;
          }
        }  
       }
    if (DuStr.length() == 0) DuStr += "НЕИЗВЕСТНЫЙ ПРОФИЛЬ " + String(currentProfile)+" ";

#ifdef params_from_pc
      sprintf (buf1, "PR%01d%01d%03d%03d%03d%02d%02d%02d%03d%03d%03d%03d%03d%03d%03d%03d%03d%03d%03d%03d%02d%02d%02d%02d%02d%02d%02d\r\n",
      profile.profileSteps %10, profile.tableSize %10, int(profile.Setpoint2), profile.min_pwr_BOTTOM, profile.max_pwr_BOTTOM, 
      (profile.rampRateStep[0]) %100,(profile.rampRateStep[1]) %100, (profile.rampRateStep[2]) %100,
      profile.temperatureStep[0],profile.temperatureStep[1],profile.temperatureStep[2],
      profile.min_pwr_TOPStep[0], profile.min_pwr_TOPStep[1], profile.min_pwr_TOPStep[2],
      profile.max_pwr_TOPStep[0],profile.max_pwr_TOPStep[1],profile.max_pwr_TOPStep[2],
      profile.dwellTimerStep[0],profile.dwellTimerStep[1],profile.dwellTimerStep[2],
      profile.kp2 %100,profile.kp1 %100, profile.ki2 %100,profile.ki1 %100,profile.kd2 %100,profile.kd1 %100,profile.BottomRampRateStep %100); 
      Serial.print(buf1);
      delay(100); 
#endif 
 return;
}
void SaveProfile () {  //  сохранение текущего профиля в EEPROM
  for (byte j=0; j<=SizeProfile-1; j++) {
    EEPROM.put(Adres+(currentProfile-1)*SizeProfile,profile);
    }
}

#ifdef params_from_pc
void ParseParameters ()  { // парсер параметров
  String st;
  sprintf (buf, "TXRecive Params%02d\r\n",ttydata.length());
  Serial.print(buf);
  st = ttydata.substring(0,1); 
  profile.profileSteps = st.toInt();
  st = ttydata.substring(1,2); 
  profile.tableSize = st.toInt();
  st = ttydata.substring(2,5); 
  profile.Setpoint2 = st.toInt();
  st = ttydata.substring(5,8); 
  profile.min_pwr_BOTTOM = st.toInt();
  st = ttydata.substring(8,11); 
  profile.max_pwr_BOTTOM = st.toInt();
  for (byte i = 0; i < 3; i++) {
          st=ttydata.substring(11+i*2,13+i*2);
          profile.rampRateStep[i] = st.toInt();
          st=ttydata.substring(17+i*3,20+i*3);
          profile.temperatureStep[i] = st.toInt();
          st=ttydata.substring(26+i*3,29+i*3);
          profile.min_pwr_TOPStep[i] = st.toInt();
          st=ttydata.substring(35+i*3,38+i*3);
          profile.max_pwr_TOPStep[i] = st.toInt();
          st=ttydata.substring(44+i*3,47+i*3);
          profile.dwellTimerStep[i] = st.toInt();
        }
  st=ttydata.substring(53,55);
  profile.kp2 = st.toInt();
  st=ttydata.substring(55,57);
  profile.kp1 = st.toInt();
  st=ttydata.substring(57,59);
  profile.ki2 = st.toInt();
  st=ttydata.substring(59,61);
  profile.ki1 = st.toInt();
  st=ttydata.substring(61,63);
  profile.kd2 = st.toInt();
  st=ttydata.substring(63,65);
  profile.kd1 = st.toInt();
  st=ttydata.substring(65,67);
  profile.BottomRampRateStep = st.toInt();
  ttydata=""; 
  SaveProfile();
  updateScreen=true;
return;
}
#endif

void ReadKey() {           // чтение кнопок 
  #ifdef resist_keyboard
  //Считываем состояние кнопок управления
  upSwitchState = digitalReadA(upSwitchPin);
  downSwitchState = digitalReadA(downSwitchPin);
  cancelSwitchState = digitalReadA(cancelSwitchPin);
  okSwitchState = digitalReadA(okSwitchPin);
  #endif
  
  #ifndef resist_keyboard
//Считываем состояние кнопок управления
  upSwitchState = !digitalRead(upSwitchPin);
  downSwitchState = !digitalRead(downSwitchPin);
  cancelSwitchState =!digitalRead(cancelSwitchPin);
  okSwitchState = !digitalRead(okSwitchPin);
  #endif  
}
void PrintName (byte prName, int XX, int YY) {
  myGLCD.setFont(BigFontRus);
  myGLCD.setColor(VGA_LIME);
  if (prName == 1) myGLCD.textRus(F("СНЯТИЕ ЧИПА БЕССВИНЕЦ "), XX, YY);
  if (prName == 2) myGLCD.textRus(F("СНЯТИЕ ЧИПА СВИНЕЦ "), XX, YY);
  if (prName == 3) myGLCD.textRus(F("УС-ВКА ЧИПА БЕССВИНЕЦ "), XX, YY);
  if (prName == 4) myGLCD.textRus(F("УС-ВКА ЧИПА СВИНЕЦ "), XX, YY);
  if (prName == 5) myGLCD.textRus(F("НИЖНИЙ ПОДОГРЕВ "), XX, YY);
}
void TonGo () {
  //Мелодия приветствия Марио
  tone(buzzerPin,1318,150);
  delay(150);
  tone(buzzerPin,1318,300);
  delay(300);
  tone(buzzerPin,1318,150);
  delay(300);
  tone(buzzerPin,1046,150);
  delay(150);
  tone(buzzerPin,1318,300);
  delay(300);
  tone(buzzerPin,1568,600);
  delay(600);
  tone(buzzerPin,784,600);
  delay(600);
  noTone(buzzerPin); 
  delay(2000);   
}
// --------------------------------------------
void PrPrint(int X, int Y) {        // номер и название профиля  
    myGLCD.setColor(VGA_BLACK);
    myGLCD.fillRoundRect(X,Y,479-X-1,Y+15);
    myGLCD.setFont(BigFont);
    myGLCD.setColor(250, 180, 000);
    myGLCD.printNumI(currentProfile, X, Y, 2);    
    myGLCD.setFont(BigFontRus);
    myGLCD.setColor(VGA_LIME);
    myGLCD.textRus(DuStr, X+40, Y);
 }

void CancelYes() {
   if (cancelSwitchState == HIGH && ( millis() - ms_button)>60)  {  
    ms_button =  millis();
    updateScreen = true;
    if (reflowState == REFLOW_STATE_STEP_RAMP  || reflowState == REFLOW_STATE_STEP 
        || reflowState == REFLOW_STATE_STEP_DWELL || reflowState == REFLOW_STATE_BOTTOM_STEP_RAMP) reflowState = REFLOW_STATE_COMPLETE;
      else reflowState = REFLOW_STATE_IDLE;
   }
}
void setup()    {
#ifndef no_pc
   Serial.begin(9600);
#endif
//setup reley pins as outputs
  pinMode(P1_PIN, OUTPUT);
  pinMode(P2_PIN, OUTPUT);
  pinMode(P3_PIN, OUTPUT);
  pinMode(P4_PIN, OUTPUT);
  pinMode(thermoCLK, OUTPUT);
  pinMode(thermoCLK2, OUTPUT);
  pinMode(thermoDO, INPUT);
  pinMode(thermoDO2, INPUT);
  pinMode(thermoCS, OUTPUT);
  pinMode(thermoCS2, OUTPUT);
  #ifndef resist_keyboard
  pinMode (upSwitchPin, INPUT_PULLUP); //подключен подтягивающий резистор
  pinMode (downSwitchPin, INPUT_PULLUP); //подключен подтягивающий резистор
  pinMode (cancelSwitchPin, INPUT_PULLUP); //подключен подтягивающий резистор
  pinMode (okSwitchPin, INPUT_PULLUP); //подключен подтягивающий резистор
  #endif
  pinMode(RelayPin1, OUTPUT);
  pinMode(RelayPin2, OUTPUT);  
  myGLCD.InitLCD();
  myGLCD.clrScr();
  #ifdef SetPicHeater
    myGLCD.drawBitmap(65, 95, 64, 64, Heater2, 1);
    #define SsPic1 150
    #define SsPic2 170
   #else
    #define SsPic1 CENTER
    #define SsPic2 CENTER
  #endif
  myGLCD.setFont(BigFont);
  myGLCD.setColor(VGA_GREEN);
  myGLCD.print(F("ARDUINO MEGA2560"),SsPic1, 105);   //CENTER
  myGLCD.setColor(VGA_RED);
  myGLCD.print(F("REWORK STATION"),SsPic2, 140);     //
  myGLCD.setColor(250, 180, 000);
  myGLCD.print(F("TFT-LCD 480*320 MAX6675_Dimmer"),CENTER, 180);
  myGLCD.setColor(VGA_SILVER);
  myGLCD.print(F("RevolveR_Dmitrysh_V4"),CENTER, 210);
  TonGo();       //Мелодия приветствия Марио
   currentProfile = 1;
   loadProfile();  //вызов функции загрузки данных профиля из eeprom    
  myGLCD.clrScr();
  nextRead1 = millis();
  #ifdef SetInterrupt
    attachInterrupt(SetInterrupt, Dimming, RISING); // настроить порт прерывания(0 или 1) 2й или 3й цифровой пин
   #else 
      MsTimer2::set(10, Dimming); // 100ms period
      MsTimer2::start();
  #endif
}
void loop()     {
  ReadKey();
  currentMillis = millis();     
  SP2 = profile.Setpoint2;
  /* Звук при нажатии на кнопки отключил (нервирует), кому надо раскоментируйте ниже 6 строк
  if (upSwitchState == HIGH || downSwitchState == HIGH || cancelSwitchState == HIGH || okSwitchState == HIGH)
    {
     tone(buzzerPin, 1045);
     delay(100);
     noTone(buzzerPin);
    } */  
  if (reflowState == REFLOW_STATE_COMPLETE || alarmOn) {
    if (i < 2 && cancelSwitchState == LOW) {
      alarmOn = true;
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      tone(buzzerPin, 1046);
      delay(100);
      noTone(buzzerPin);
      delay(100);
      i++;
      }
     else {
      i = 0;
      alarmOn = false;
      }
    }
  CancelYes();
  switch (reflowState)   {
    case REFLOW_STATE_IDLE: {                   // главный экран    
      TopStart = false;
      currentStep = 1;
      counter = 0;
      setpointRamp = 0;
      
      x = 1;             // устанавливаем переменную в исходное состояние
      flag = 0;          // после остановки профиля сбрасываем флаг
  
      Output1=0;
      Output2=0;

      if (millis() > nextRead1)     {
        // Read thermocouples next sampling period
        nextRead1 =millis()+ SENSOR_SAMPLING_TIME;

        Input1 = Input1*0.8 + 0.2*(max6675_read_temp (thermoCLK,thermoCS,thermoDO));
        Input2 = Input2*0.8 + 0.2*(max6675_read_temp (thermoCLK2,thermoCS2,thermoDO2));

        tc1 = Input1;
        tc2 = Input2;
#ifdef params_from_pc
//блок обработки данных с ПЭВМ--------------------------------------------------------------------
 int b1,b2=0;
    b2=Serial.available();
    if (b2 > 0) {
     b1 = Serial.read();
    if ((b1 == 'P') ) {
      sprintf (buf, "TXSend Params\r\n");
      Serial.print(buf);
      delay(50);
      loadProfile();
    }
      if (b1=='N') {
      ttydata=ttydata+Serial.readString();
      sprintf (buf, "TXRecive Params%02d\r\n",b2);
      Serial.println(buf);
      Serial.println("TX"+ttydata);
      if (ttydata.length()==67) 
              {
                Serial.println("TXParsing...\r\n");
                ParseParameters();
              }
      if (ttydata.length()>67) 
      {
        ttydata="";
        Serial.print("TXERROR on reciever");
      }
     } 
   }     
//-------------------------------------------------------------------------------------------------- 
#endif     
#ifndef no_pc  
      sprintf (buf, "OK%03d%03d%03d%03d%03d\r\n", (Output1), (Output2), tc1, tc2, (profileName)); 
      Serial.print(buf);
#endif 
      if (isnan(Input1)) {
          myGLCD.setColor(VGA_BLACK);
          myGLCD.drawRoundRect(340,100,460,180);
          myGLCD.setFont(BigFont);
          myGLCD.setColor(VGA_RED);
          myGLCD.print(F("ERORR"),360, 140);
        } else {
          myGLCD.setFont(SevenSegNumFont);
          myGLCD.setColor(VGA_SILVER);
          myGLCD.printNumI(tc1,345, 120,3,'0');
        }
        if (isnan(Input2)) {
          myGLCD.setFont(BigFont);
          myGLCD.setColor(VGA_RED);
          myGLCD.print(F("ERORR"),360, 250);
        } else {
          myGLCD.setFont(SevenSegNumFont);
          myGLCD.setColor(VGA_SILVER);
          myGLCD.printNumI(tc2,345, 232,3,'0');
        }
      }   
      if (updateScreen) {     //Настройка экрана Рабочий режим
        myGLCD.clrScr();
        myGLCD.setFont(BigFontRus);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.textRus(F("` "),155, 115);
        myGLCD.textRus(F("`/с "),175, 133);
        myGLCD.textRus(F("`/с "),175, 245);
        myGLCD.textRus(F("` "),155, 227);
        myGLCD.textRus(F("` "),450, 123);
        myGLCD.textRus(F("` "),450, 235);
		myGLCD.setColor(100,100,100);    // "вкладка" 
		myGLCD.drawLine(195,108,210,78); //   для
		myGLCD.drawLine(210,78,475,78);  // мощности
		myGLCD.drawLine(475,78,475,108); //  верха
		myGLCD.drawLine(195,106,475,106);//
		
		myGLCD.setColor(100,100,100);    // "вкладка" 
		myGLCD.drawLine(195,221,210,191); //   для
		myGLCD.drawLine(210,191,475,191);  // мощности
		myGLCD.drawLine(475,191,475,221); //   низа
		myGLCD.drawLine(197,219,475,219);//
		myGLCD.setColor(30,30,30);
		myGLCD.textRus(F("График Температуры"),90, 20);
        myGLCD.setColor(VGA_SILVER);
		myGLCD.textRus(F("Мощность      % "),230, 84);
		myGLCD.textRus(F("Мощность      % "),230, 198);
        myGLCD.drawRoundRect(3,108,478,179);
        myGLCD.drawRoundRect(3,221,478,291);
		myGLCD.setColor(40,40,40);      // верхний график 
        myGLCD.drawRect(1,1,479,72);    //температуры
        //myGLCD.drawRect(224,221,478,291);
        myGLCD.setColor(VGA_SILVER);
		myGLCD.drawLine(224,108,224,179); //разделитель
		myGLCD.drawLine(224,221,224,291); //
        myGLCD.textRus(F("ВЕРХ-> "),5, 115);
        myGLCD.textRus(F("НИЗ -> "),5, 227);
		myGLCD.textRus(F("Рост= "),5, 133);
        myGLCD.textRus(F("Рост= "),5, 245);
        updateScreen = false;
     PrPrint(5,300);
      }
      myGLCD.setFont(BigFont);
      myGLCD.setColor(VGA_SILVER);
      myGLCD.printNumI(profile.temperatureStep[editStep],100, 115,3,'0');
      myGLCD.printNumI(SP2,100, 227,3,'0');
              
      if (upSwitchState == HIGH && ( millis() - ms_button)>500) {      //if up switch is pressed go to next profile      
        ms_button =  millis();
        currentProfile = currentProfile + 1;
        if (currentProfile > numMax)  currentProfile = 1;    //if currentProfile = 5 and up is pressed go back to profile 1
        //Serial.println(currentProfile);
        loadProfile();//вызов функции loadProfile для загрузки данных профиля из eeprom    
        PrPrint(5,300);
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>500) {     //same as above just go down one profile      
        ms_button =  millis();
        currentProfile = currentProfile - 1;
        if (currentProfile <= 0)  currentProfile = numMax;
        loadProfile();//вызов функции loadProfile для загрузки данных профиля из eeprom    
        PrPrint(5,300);
        }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100) { //фиксируем момент нажатия кнопки "ОК" + защита от дребезга     
        ms_button =  millis();
        button_state = true;
        button_long_state = false;
        }     
      if (okSwitchState == HIGH && !button_long_state && ( millis() - ms_button)>1500) {  //держим "ОК" 3+ секунды и заходим в меню настроек       
        button_long_state = true;
        button_state = false;
        reflowState = REFLOW_STATE_MENU_STEPS;
        updateScreen = true;		
        }     
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100) { //включаем пайку, кнопка сработает после отпускания "ОК"        
        ms_button =  millis();
        button_state = false;
        tone(buzzerPin, 1045, 500);  //звуковой сигнал при старте профиля
        #ifndef no_pc
        sprintf (buf, "SYNC\r\n"); 
        Serial.print(buf);
        #endif 
        integra=0;
        integra2=0;
        updateScreen = true;
        Xgr=2;
        XTgr=2;
        reflowStatus = REFLOW_STATUS_ON;
        reflowState = REFLOW_STATE_TABLE_SIZE;
        }
      }
      break;
    case REFLOW_STATE_MENU_STEPS:   {           // устанавливаем количество шагов профиля
      if (updateScreen){
        myGLCD.clrScr();
        myGLCD.setFont(BigFontRus);
        PrPrint(5,20);
        myGLCD.setColor(VGA_RED);
        myGLCD.textRus(F("НИЖНИЙ НАГРЕВАТЕЛЬ "),90, 55);
        myGLCD.setColor(VGA_LIME);
        myGLCD.textRus(F("К-ВО ШАГОВ "),10, 100);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.textRus(F("РАЗМЕР НИЗА "),260, 100);
        myGLCD.textRus(F("СКОРОСТЬ НАГРЕВА НИЗОМ "),5, 140);
        myGLCD.textRus(F("ТЕМПЕРАТУРА НИЗ "),5, 180);
        myGLCD.textRus(F("МОЩНОСТЬ НИЗ "),280, 180);
        myGLCD.textRus(F("МИН "),320, 220);
        myGLCD.textRus(F("МАХ "),320, 260);
        myGLCD.textRus(F("` "),180, 223);
        myGLCD.textRus(F("% "),430, 220);
        myGLCD.textRus(F("% "),430, 260);
        myGLCD.printNumI(profile.tableSize,450, 100);
        myGLCD.printNumF(profile.BottomRampRateStep*0.1,0,380,140);
        myGLCD.printNumI(profile.min_pwr_BOTTOM,380, 220,3,' ');
        myGLCD.printNumI(profile.max_pwr_BOTTOM,380, 260,3,' ');
        myGLCD.setFont(SevenSegNumFont);
        myGLCD.printNumI(SP2,75, 220);
        myGLCD.setColor(250, 180, 000);
        myGLCD.drawRoundRect(5,93,200,121);
        myGLCD.setFont(BigFontRus);
        myGLCD.printNumI(profile.profileSteps,180, 100);
        PrintName (profileName, 120, 20);
        updateScreen = false;
      }
        myGLCD.setColor(250, 180, 000);
        myGLCD.printNumI(profile.profileSteps,180, 100);

      if (upSwitchState == HIGH && ( millis() - ms_button)>100)     {
        ms_button =  millis();
        profile.profileSteps = profile.profileSteps + 1;
        if (profile.profileSteps >= 4)  profile.profileSteps = 1;
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)   {
        ms_button =  millis();
        profile.profileSteps = profile.profileSteps - 1;
        if (profile.profileSteps <= 0)  profile.profileSteps = 3;
        }      
      if (okSwitchState == LOW && button_long_state) button_long_state = false; //чтобы после входа в меню не кнопка "ОК" не считалась нажатой      
      if (okSwitchState == HIGH && !button_state && !button_long_state && ( millis() - ms_button)>100)  {
        ms_button =  millis();
        button_state = true;
        }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)   {        
        ms_button =  millis();
        button_state = false;
        SaveProfile();
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_TABLE_SIZE;
        }
      }
      break;
    case REFLOW_STATE_MENU_TABLE_SIZE:  {       // устанавливаем размер стола
       if (updateScreen){
        myGLCD.setColor(VGA_BLACK);
        myGLCD.drawRoundRect(5,93,200,121);
        myGLCD.setFont(BigFontRus);
        myGLCD.setColor(VGA_LIME);
        myGLCD.textRus(F("РАЗМЕР НИЗА "),260, 100);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.textRus(F("К-ВО ШАГОВ "),10, 100);
        myGLCD.printNumI(profile.profileSteps,180, 100);
        myGLCD.setFont(SevenSegNumFont);
        myGLCD.setColor(250, 180, 000);
        myGLCD.drawRoundRect(250,93,475,121);
        myGLCD.setFont(BigFontRus);
        myGLCD.printNumI(profile.tableSize,450, 100);
        updateScreen = false;
        }
      myGLCD.printNumI(profile.tableSize,450, 100);
      if (upSwitchState == HIGH && ( millis() - ms_button)>100) {
        ms_button =  millis();
        profile.tableSize = profile.tableSize + 1;
        if (profile.tableSize >= 4)  profile.tableSize = 1;
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100) {
        ms_button =  millis();
        profile.tableSize = profile.tableSize - 1;
        if (profile.tableSize <= 0) profile.tableSize = 3;
        }      
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)  {
        ms_button =  millis();
        button_state = true;
        }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)   {        
        ms_button =  millis();
        button_state = false;
        SaveProfile();
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_BOTTOM_RAMP;
        }
      }  
      break;  
    case REFLOW_STATE_MENU_BOTTOM_RAMP:    {    //устанавливаем скорость нагрева "Нижним Нагревателем"
      if (updateScreen){
        //myGLCD.setColor(VGA_BLACK);
        //myGLCD.drawRoundRect(275,175,475,203);
        myGLCD.setColor(VGA_BLACK);
        myGLCD.drawRoundRect(250,93,475,121);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.textRus(F("РАЗМЕР НИЗА "),260, 100);
        myGLCD.printNumI(profile.tableSize,450, 100);

        //myGLCD.setColor(VGA_SILVER);
        //myGLCD.textRus(F("МОЩНОСТЬ НИЗ "),280, 180);
        //myGLCD.textRus(F("МАХ "),320, 260);
        //myGLCD.printNumI(profile.max_pwr_BOTTOM,380, 260,3,'0');
        myGLCD.setColor(VGA_LIME);
        myGLCD.textRus(F("СКОРОСТЬ НАГРЕВА НИЗОМ "),5, 140);
        myGLCD.setColor(250, 180, 000);
        myGLCD.drawRoundRect(0,133,360,161);
        updateScreen = false;
       }
      myGLCD.printNumF(profile.BottomRampRateStep*0.1,0,380,140);
     
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)     {
        ms_button =  millis();
        profile.BottomRampRateStep = profile.BottomRampRateStep + 1;
        if (profile.BottomRampRateStep >= 99)  profile.BottomRampRateStep = 99;
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)   {
        ms_button =  millis();
        profile.BottomRampRateStep = profile.BottomRampRateStep - 1;
        if (profile.BottomRampRateStep <= 1)  profile.BottomRampRateStep = 1;
        }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)  {
        ms_button =  millis();
        button_state = true;
        }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)    {        
        ms_button =  millis();
        button_state = false;
        SaveProfile();
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_BOTTOM_HEAT;
        }
      }
      break;
    case REFLOW_STATE_MENU_BOTTOM_HEAT:    {    // устанавливаем температуру "Нижнего Нагревателя"
      if (updateScreen) {
        myGLCD.setFont(BigFontRus);
        myGLCD.setColor(VGA_BLACK);
        myGLCD.drawRoundRect(0,133,360,161);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.textRus(F("СКОРОСТЬ НАГРЕВА НИЗОМ "),5, 140);
        myGLCD.printNumF(profile.BottomRampRateStep*0.1,0,380,140);
        myGLCD.setColor(VGA_LIME);
        myGLCD.textRus(F("ТЕМПЕРАТУРА НИЗ "),5, 180);
        myGLCD.setColor(250, 180, 000); 
        myGLCD.drawRoundRect(2,175,258,203);
        updateScreen = false;
        }
      myGLCD.setFont(SevenSegNumFont);
      myGLCD.printNumI(SP2,75, 220,3,'0');
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)   {
        ms_button =  millis();
        profile.Setpoint2 = profile.Setpoint2 + 1;
        if (profile.Setpoint2 >= 250)  profile.Setpoint2 = 250;
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100) {
        ms_button =  millis();
        profile.Setpoint2 = profile.Setpoint2 - 1;
        if (profile.Setpoint2 <= 50) profile.Setpoint2 = 50;
        }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100) {
        ms_button =  millis();
        button_state = true;
        }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)   {        
        ms_button =  millis();
        button_state = false;
        SaveProfile();
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_BOTTOM_PWR_MIN;
        }
      }
      break;    
    case REFLOW_STATE_MENU_BOTTOM_PWR_MIN: {    // устанавливаем минимальную мощность "НИЖНЕГО НАГРЕВАТЕЛЯ" 
      if (updateScreen){
        myGLCD.setFont(BigFontRus);        
        myGLCD.setColor(VGA_BLACK);
        myGLCD.drawRoundRect(2,175,258,203);
        myGLCD.setColor(VGA_LIME);
        myGLCD.textRus(F("МОЩНОСТЬ НИЗ "),280, 180);
        myGLCD.textRus(F("МИН "),320, 220);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.textRus(F("ТЕМПЕРАТУРА НИЗ "),5, 180);
        myGLCD.setFont(SevenSegNumFont);
        myGLCD.printNumI(SP2,75, 220);
        myGLCD.setColor(250, 180, 000);
        myGLCD.drawRoundRect(275,175,475,203);
        updateScreen = false;
      }
      myGLCD.setFont(BigFontRus);
      myGLCD.printNumI(profile.min_pwr_BOTTOM,380, 220,3,' ');      
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)   {
        ms_button =  millis();
        profile.min_pwr_BOTTOM = profile.min_pwr_BOTTOM + 1;
        if (profile.min_pwr_BOTTOM >= 100)   profile.min_pwr_BOTTOM = 100;
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100) {
        ms_button =  millis();
        profile.min_pwr_BOTTOM = profile.min_pwr_BOTTOM - 1;
        if (profile.min_pwr_BOTTOM <= 0) profile.min_pwr_BOTTOM = 0;
        }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)  {
        ms_button =  millis();
        button_state = true;
        }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)    {        
        ms_button =  millis();
        button_state = false;
        SaveProfile();
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_BOTTOM_PWR_MAX;
        }
      }
      break;
    case REFLOW_STATE_MENU_BOTTOM_PWR_MAX: {    // устанавливаем максимальную мощность "НИЖНЕГО НАГРЕВАТЕЛЯ"     
      if (updateScreen){
        myGLCD.setFont(BigFontRus);        
        myGLCD.setColor(VGA_BLACK);
        myGLCD.drawRoundRect(2,175,258,203);
        myGLCD.setColor(VGA_LIME);
        myGLCD.textRus(F("МОЩНОСТЬ НИЗ "),280, 180);
        myGLCD.textRus(F("МАХ "),320, 260);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.textRus(F("МИН "),320, 220);
        myGLCD.printNumI(profile.min_pwr_BOTTOM,380, 220,3,' ');
        myGLCD.setColor(250, 180, 000);
        myGLCD.drawRoundRect(275,175,475,203);
        updateScreen = false;
      }
      myGLCD.printNumI(profile.max_pwr_BOTTOM,380, 260,3,' ');      
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)  {
        ms_button =  millis();
        profile.max_pwr_BOTTOM = profile.max_pwr_BOTTOM + 1;
        if (profile.max_pwr_BOTTOM >= 100) profile.max_pwr_BOTTOM = 100;
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100) {
        ms_button =  millis();
        profile.max_pwr_BOTTOM = profile.max_pwr_BOTTOM - 1;
        if (profile.max_pwr_BOTTOM <= 0) profile.max_pwr_BOTTOM = 0;
        }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100) {
        ms_button =  millis();
        button_state = true;
        }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)  {        
        ms_button =  millis();
        button_state = false;
        SaveProfile();
        updateScreen = true;
        myGLCD.clrScr();        
        reflowState = REFLOW_STATE_MENU_STEP_RAMP;
        editStep = 0;
        }
      }
      break;      
    case REFLOW_STATE_MENU_STEP_RAMP:     {     // устанавливаем скорость нагрева "Верхним Нагревателем"
      if (updateScreen) {
        myGLCD.setFont(BigFontRus);
        PrPrint(5,20);
        myGLCD.setColor(VGA_RED);
        myGLCD.textRus(F("ВЕРХНИЙ НАГРЕВАТЕЛЬ "),120, 55);
        myGLCD.setColor(VGA_LIME);
        myGLCD.textRus(F("СКОРОСТЬ НАГРЕВА ВЕРХОМ "),15, 90);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.textRus(F("ШАГ: "),0, 55);
        myGLCD.textRus(F("ТЕМП-РА ВЕРХ "),5, 140);
        myGLCD.textRus(F("МОЩНОСТЬ ВЕРХ "),260, 140);
        myGLCD.textRus(F("МИН "),310, 180);
        myGLCD.textRus(F("МАХ "),310, 220);
        myGLCD.printNumI(profile.min_pwr_TOPStep[editStep],370, 180,3,' ');
        myGLCD.printNumI(profile.max_pwr_TOPStep[editStep],370, 220,3,' ');
        myGLCD.textRus(F("ВРЕМЯ ПЕРЕХОДА НА СЛЕД ШАГ "),5, 270);
        myGLCD.textRus(F("с "),460, 90);
        myGLCD.textRus(F("с "),462, 270);
        myGLCD.textRus(F("` "),160, 183);
        myGLCD.textRus(F("% "),420, 180);
        myGLCD.textRus(F("% "),420, 220);
        myGLCD.setColor(250, 180, 000);
        myGLCD.drawRoundRect(12,85,390,112);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.setFont(SevenSegNumFont);
        myGLCD.printNumI(profile.temperatureStep[editStep],55, 180,3,'0');
        myGLCD.setFont(BigFont);
        myGLCD.printNumI(profile.dwellTimerStep[editStep],427, 270,2,'0');
        myGLCD.setColor(250, 180, 000);
        myGLCD.printNumI(editStep + 1,70, 55);
        myGLCD.setFont(BigFontRus);
        myGLCD.setColor(VGA_LIME);
        if (profileName == 1) myGLCD.textRus(F("СНЯТИЕ ЧИПА БЕССВИНЕЦ "),120, 20);
        if (profileName == 2) myGLCD.textRus(F("СНЯТИЕ ЧИПА СВИНЕЦ "),120, 20);
        if (profileName == 3) myGLCD.textRus(F("УС-ВКА ЧИПА БЕССВИНЕЦ "),120, 20);
        if (profileName == 4) myGLCD.textRus(F("УС-ВКА ЧИПА СВИНЕЦ "),120, 20);
        if (profileName == 5) myGLCD.textRus(F("НИЖНИЙ ПОДОГРЕВ "),120, 20);
        updateScreen = false;
        }
      myGLCD.setColor(250, 180, 000);
      myGLCD.printNumF(profile.rampRateStep[editStep] * 0.1,0, 405, 90);        
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)     {
        ms_button =  millis();
        profile.rampRateStep[editStep] = profile.rampRateStep[editStep] + 1;
        if (profile.rampRateStep[editStep] >= 30)  profile.rampRateStep[editStep] = 30;  //максимальная скорость роста температуры от 0.1с. до 3с.
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)   {
        ms_button =  millis();
        profile.rampRateStep[editStep] = profile.rampRateStep[editStep] - 1;
        if (profile.rampRateStep[editStep] <= 1)  profile.rampRateStep[editStep] = 1;  //минимальная скорость роста температуры от 3с. до 0.1с.
        }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)  {
        ms_button =  millis();
        button_state = true;
        }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)    {        
        ms_button =  millis();
        button_state = false;
        reflowState = REFLOW_STATE_MENU_STEP_TARGET;
        SaveProfile();
        myGLCD.setColor(VGA_SILVER);
        myGLCD.textRus(F("СКОРОСТЬ НАГРЕВА ВЕРХОМ "),15, 90);
        myGLCD.printNumF(profile.rampRateStep[editStep] * 0.1,0, 405, 90);        
        myGLCD.setColor(VGA_BLACK);
        myGLCD.drawRoundRect(12,85,390,112);        
        updateScreen = true;
        }
      }
      break;
    case REFLOW_STATE_MENU_STEP_TARGET:   {     // устанавливаем температуру "Верхнего Нагревателя"
      if (updateScreen) {
        myGLCD.setFont(BigFontRus);
        myGLCD.setColor(VGA_LIME);
        myGLCD.textRus(F("ТЕМП-РА ВЕРХ "),5, 140); 
        myGLCD.setColor(250, 180, 000);
        myGLCD.drawRoundRect(2,131,200,160);
        myGLCD.setFont(SevenSegNumFont);
        myGLCD.printNumI(profile.temperatureStep[editStep],55, 180,3,'0');       
        updateScreen = false;
      }
      myGLCD.printNumI(profile.temperatureStep[editStep],55, 180,3,'0');        
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)    {
        ms_button =  millis();
        profile.temperatureStep[editStep] = profile.temperatureStep[editStep] + 1;
        if (profile.temperatureStep[editStep] > 250)   profile.temperatureStep[editStep] = 250;
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)  {
        ms_button =  millis();
        profile.temperatureStep[editStep] = profile.temperatureStep[editStep] - 1;
        if (profile.temperatureStep[editStep] < 0)   profile.temperatureStep[editStep] = 0;
        if (profile.temperatureStep[editStep] <= 99) myGLCD.printNumI(profile.temperatureStep[editStep],180, 160);
        if (profile.temperatureStep[editStep] <= 9)  myGLCD.printNumI(profile.temperatureStep[editStep],180, 160);        
        }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)   {
        ms_button =  millis();
        button_state = true;
        }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)     {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_TOP_PWR_MIN;
        SaveProfile();
        }
      }
       break;  
    case REFLOW_STATE_MENU_TOP_PWR_MIN:  {     // устанавливаем минимальную мощность "ВЕРХНЕГО НАГРЕВАТЕЛЯ"   
      if (updateScreen)  {
        myGLCD.setFont(BigFontRus);        
        myGLCD.setColor(VGA_BLACK);
        myGLCD.drawRoundRect(2,131,200,160);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.textRus(F("ТЕМП-РА ВЕРХ "),5, 140);
        myGLCD.printNumF(profile.rampRateStep[editStep] * 0.1,0, 405, 90);
        myGLCD.setFont(SevenSegNumFont);
        myGLCD.printNumI(profile.temperatureStep[editStep],55, 180,3,'0');
        myGLCD.setFont(BigFontRus);
        myGLCD.setColor(VGA_LIME);
        myGLCD.textRus(F("МОЩНОСТЬ ВЕРХ "),260, 140);
        myGLCD.textRus(F("МИН "),310, 180);
        myGLCD.setColor(250, 180, 000);
        myGLCD.printNumI(editStep + 1,70, 55);
        myGLCD.drawRoundRect(255,131,470,160);
        myGLCD.setFont(BigFontRus);
        myGLCD.printNumI(profile.min_pwr_TOPStep[editStep],370, 180,3,' ');
        updateScreen = false;
        }
      myGLCD.printNumI(profile.min_pwr_TOPStep[editStep],370, 180,3,' ');      
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)    {
        ms_button =  millis();
        profile.min_pwr_TOPStep[editStep] = profile.min_pwr_TOPStep[editStep] + 1;
        if (profile.min_pwr_TOPStep[editStep] > 100)  profile.min_pwr_TOPStep[editStep] = 100;        
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)  {
        ms_button =  millis();
        profile.min_pwr_TOPStep[editStep] = profile.min_pwr_TOPStep[editStep] - 1;
        if (profile.min_pwr_TOPStep[editStep] < 0)  profile.min_pwr_TOPStep[editStep] = 0;
        }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)  {
        ms_button =  millis();
        button_state = true;
        }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)    {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_TOP_PWR_MAX;
        SaveProfile();
        }
      }
      break; 
    case REFLOW_STATE_MENU_TOP_PWR_MAX:  {     // устанавливаем максимальную мощность "ВЕРХНЕГО НАГРЕВАТЕЛЯ"     
      if (updateScreen)   {
        myGLCD.setFont(BigFontRus);        
        myGLCD.setColor(VGA_BLACK);
        myGLCD.drawRoundRect(2,131,200,160);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.textRus(F("МИН "),310, 180);
        myGLCD.printNumI(profile.min_pwr_TOPStep[editStep],370, 180,3,' ');
        myGLCD.printNumF(profile.rampRateStep[editStep] * 0.1,0, 405, 90);
        myGLCD.setFont(SevenSegNumFont);
        myGLCD.printNumI(profile.temperatureStep[editStep],55, 180,3,'0');
        myGLCD.setFont(BigFontRus);
        myGLCD.setColor(VGA_LIME);
        myGLCD.textRus(F("МАХ "),310, 220);
        myGLCD.setColor(250, 180, 000);
        myGLCD.printNumI(editStep + 1,70, 55);
        myGLCD.drawRoundRect(255,131,470,160);
        myGLCD.setFont(BigFontRus);
        myGLCD.printNumI(profile.max_pwr_TOPStep[editStep],370, 220,3,' ');
        updateScreen = false;
        }
      myGLCD.printNumI(profile.max_pwr_TOPStep[editStep],370, 220,3,' ');      
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)      {
        ms_button =  millis();
        profile.max_pwr_TOPStep[editStep] = profile.max_pwr_TOPStep[editStep] + 1;
        if (profile.max_pwr_TOPStep[editStep] > 100)   profile.max_pwr_TOPStep[editStep] = 100;
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)    {
        ms_button =  millis();
        profile.max_pwr_TOPStep[editStep] = profile.max_pwr_TOPStep[editStep] - 1;
        if (profile.max_pwr_TOPStep[editStep] <= 0)   profile.max_pwr_TOPStep[editStep] = 0;
        }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)   {
        ms_button =  millis();
        button_state = true;
        }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)     {        
        ms_button =  millis();
        button_state = false;
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_STEP_DWELL;
        SaveProfile();
        }
      }
      break;
    case REFLOW_STATE_MENU_STEP_DWELL:    {     // устанавливаем время перехода на следующий шаг
      if (updateScreen) {
        myGLCD.setFont(BigFontRus);
        myGLCD.setColor(VGA_BLACK);
        myGLCD.drawRoundRect(255,131,470,160);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.textRus(F("МОЩНОСТЬ ВЕРХ "),260, 140);
        myGLCD.textRus(F("МАХ "),310, 220);
        myGLCD.printNumI(profile.max_pwr_TOPStep[editStep],370, 220,3,' ');
        myGLCD.printNumF(profile.rampRateStep[editStep] * 0.1,0, 405, 90);
        myGLCD.setFont(SevenSegNumFont);
        myGLCD.printNumI(profile.temperatureStep[editStep],55, 180,3,'0');
        myGLCD.setFont(BigFontRus);
        myGLCD.setColor(VGA_LIME);
        myGLCD.textRus(F("ВРЕМЯ ПЕРЕХОДА НА СЛЕД ШАГ "),5, 270);
        myGLCD.setColor(250, 180, 000);
        myGLCD.drawRoundRect(2,263,420,290);
        myGLCD.printNumI(editStep + 1 ,70, 55);
        myGLCD.printNumI(profile.dwellTimerStep[editStep],427, 270,2,'0');
        updateScreen = false;
       }
      myGLCD.printNumI(profile.dwellTimerStep[editStep],427, 270,2,'0');
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)     {
        ms_button =  millis();
        profile.dwellTimerStep[editStep] = profile.dwellTimerStep[editStep] + 5;
        if (profile.dwellTimerStep[editStep] > 90)   profile.dwellTimerStep[editStep] = 90;
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)   {
        ms_button =  millis();
        profile.dwellTimerStep[editStep] = profile.dwellTimerStep[editStep] - 5;
        if (profile.dwellTimerStep[editStep] < 0)   profile.dwellTimerStep[editStep] = 0;
        }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)     {
        ms_button =  millis();
        button_state = true;
        }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)       {        
        ms_button =  millis();
        button_state = false;
        SaveProfile();
        updateScreen = true;
        if (editStep + 1 == profile.profileSteps) {
          editStep = 0;
          reflowState = REFLOW_STATE_MENU_BOTTOM_P;
          }
        else  {           
          myGLCD.setColor(VGA_SILVER);     
          myGLCD.textRus(F("ВРЕМЯ ПЕРЕХОДА НА СЛЕД ШАГ "),5, 270);
          myGLCD.printNumI(profile.dwellTimerStep[editStep],427, 270,2,'0');          
          reflowState = REFLOW_STATE_MENU_STEP_RAMP;
          myGLCD.setColor(VGA_BLACK);
          myGLCD.drawRoundRect(2,263,420,290);
          editStep++; 
          }
        }
      }
      break;
    case REFLOW_STATE_MENU_BOTTOM_P:      {     // настройка "ПИД" нижнего нагревателя
      if (updateScreen) {
        myGLCD.clrScr();
        myGLCD.setFont(BigFontRus);
        myGLCD.setColor(VGA_RED);
        myGLCD.textRus(F("НАСТРОЙКА ПИД "),130, 5);
        myGLCD.setColor(VGA_LIME);
        myGLCD.textRus(F("НИЖНИЙ НАГРЕВАТЕЛЬ "),90, 35);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.textRus(F("ВЕРХНИЙ НАГРЕВАТЕЛЬ "),85, 170);
        myGLCD.setFont(SevenSegNumFont);
        myGLCD.printNumI(profile.ki2,200, 100,3,'0');
        myGLCD.printNumI(profile.kd2,375, 100,3,'0');
        myGLCD.printNumI(profile.ki1,200, 240,3,'0');
        myGLCD.printNumI(profile.kd1,375, 240,3,'0');
        myGLCD.printNumI(profile.kp1,25, 240,3,'0');  

        myGLCD.setFont(BigFont);
        myGLCD.print(F("I= "),230, 70);
        myGLCD.print(F("D= "),405, 70);
        myGLCD.print(F("P= "),55, 205);
        myGLCD.print(F("I= "),230, 205);
        myGLCD.print(F("D= "),405, 205);
        
        myGLCD.setColor(250, 180, 000);
        myGLCD.print(F("P="),55, 70);
        myGLCD.setFont(SevenSegNumFont);
        myGLCD.drawRoundRect(80,28,390,55);
        myGLCD.printNumI(profile.kp2,25, 100,3,'0');
        updateScreen = false;
      }
      myGLCD.printNumI(profile.kp2,25, 100,3,'0');        
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)    {
        ms_button =  millis();
        profile.kp2 = profile.kp2 + 1;
        if (profile.kp2 >= 255)  profile.kp2 = 255;
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)  {
        ms_button =  millis();
        profile.kp2 = profile.kp2 - 1;
        if (profile.kp2 <= 0)   profile.kp2 = 0;
        }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)    {
        ms_button =  millis();
        button_state = true;
        }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)      {        
        ms_button =  millis();
        button_state = false;
        SaveProfile();
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_BOTTOM_I;
        }
      }
      break;
    case REFLOW_STATE_MENU_BOTTOM_I:      {
        myGLCD.setFont(BigFont);
        myGLCD.setColor(250, 180, 000);
        myGLCD.print(F("I="),230, 70);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.print(F("P="),55, 70);
        myGLCD.setFont(SevenSegNumFont);
        myGLCD.printNumI(profile.kp2,25, 100,3,'0');
        myGLCD.setColor(250, 180, 000);
        myGLCD.printNumI(profile.ki2,200, 100,3,'0');       
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)    {
        ms_button =  millis();
        profile.ki2 = profile.ki2 + 1;
        if (profile.ki2 >= 255)   profile.ki2 = 255;
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)  {
        ms_button =  millis();
        profile.ki2 = profile.ki2 - 1;
        if (profile.ki2 <= 0)  profile.ki2 = 0;
        }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)   {
        ms_button =  millis();
        button_state = true;
        }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)     {        
        ms_button =  millis();
        button_state = false;
        SaveProfile();
        reflowState = REFLOW_STATE_MENU_BOTTOM_D;
        }
      }
      break;
    case REFLOW_STATE_MENU_BOTTOM_D:      {
        myGLCD.setFont(BigFont);
        myGLCD.setColor(250, 180, 000);
        myGLCD.print(F("D="),405, 70);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.print(F("I="),230, 70);
        myGLCD.setFont(SevenSegNumFont);
        myGLCD.printNumI(profile.ki2,200, 100,3,'0');
        myGLCD.setColor(250, 180, 000);
        myGLCD.printNumI(profile.kd2,375, 100,3,'0');       
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)    {
        ms_button =  millis();
        profile.kd2 = profile.kd2 + 1;
        if (profile.kd2 >= 255)  profile.kd2 = 255;
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)  {
        ms_button =  millis();
        profile.kd2 = profile.kd2 - 1;
        if (profile.kd2 <= 0)  profile.kd2 = 0;
        }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)   {
        ms_button =  millis();
        button_state = true;
        }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)     {        
        ms_button =  millis();
        button_state = false;
        SaveProfile();
        reflowState = REFLOW_STATE_MENU_TOP_P;
        }
      }
      break;
    case REFLOW_STATE_MENU_TOP_P:         {       //настройка "ПИД" верхнего нагревателя
      if (updateScreen) {
        myGLCD.setFont(BigFontRus);
        myGLCD.setColor(250, 180, 000);
        myGLCD.print(F("P= "),55, 205);
        myGLCD.setColor(VGA_LIME);
        myGLCD.textRus(F("ВЕРХНИЙ НАГРЕВАТЕЛЬ "),85, 170);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.textRus(F("НИЖНИЙ НАГРЕВАТЕЛЬ "),90, 35);
        myGLCD.setFont(BigFont);
        myGLCD.print(F("D= "),405, 70);
        myGLCD.setFont(SevenSegNumFont);
        myGLCD.printNumI(profile.kd2,375, 100,3,'0');
        myGLCD.printNumI(profile.ki1,200, 240,3,'0');
        myGLCD.printNumI(profile.kd1,375, 240,3,'0');
        myGLCD.setColor(VGA_BLACK);
        myGLCD.drawRoundRect(80,28,390,55);
        myGLCD.setColor(250, 180, 000);
        myGLCD.drawRoundRect(80,163,394,190);
        myGLCD.printNumI(profile.kp1,25, 240,3,'0');
        updateScreen = false;
      }
      myGLCD.printNumI(profile.kp1,25, 240,3,'0');  
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)    {
        ms_button =  millis();
        profile.kp1 = profile.kp1 + 1;
        if (profile.kp1 >= 255) profile.kp1 = 255;
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)  {
        ms_button =  millis();
        profile.kp1 = profile.kp1 - 1;
        if (profile.kp1 <= 0)  profile.kp1 = 0;
        }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)   {
        ms_button =  millis();
        button_state = true;
        }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)     {        
        ms_button =  millis();
        button_state = false;
        SaveProfile();
        updateScreen = true;
        reflowState = REFLOW_STATE_MENU_TOP_I;
        }
      }
      break;
    case REFLOW_STATE_MENU_TOP_I:         {
        myGLCD.setFont(BigFont);
        myGLCD.setColor(250, 180, 000);
        myGLCD.print(F("I="),230, 205);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.print(F("P="),55, 205);
        myGLCD.setFont(SevenSegNumFont);
        myGLCD.printNumI(profile.kp1,25, 240,3,'0');
        myGLCD.setColor(250, 180, 000);
        myGLCD.printNumI(profile.ki1,200, 240,3,'0');        
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)    {
        ms_button =  millis();
        profile.ki1 = profile.ki1 + 1;
        if (profile.ki1 >= 255) profile.ki1 = 255;
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100)  {
        ms_button =  millis();
        profile.ki1 = profile.ki1 - 1;
        if (profile.ki1 <= 0)  profile.ki1 = 0;
        }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)   {
        ms_button =  millis();
        button_state = true;
        }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)     {        
        ms_button =  millis();
        button_state = false;
        SaveProfile();
        reflowState = REFLOW_STATE_MENU_TOP_D;
        }
      }
      break;
    case REFLOW_STATE_MENU_TOP_D:         {
        myGLCD.setFont(BigFont);
        myGLCD.setColor(250, 180, 000);
        myGLCD.print(F("D="),405, 205);
        myGLCD.setColor(VGA_SILVER);
        myGLCD.print(F("I="),230, 205);
        myGLCD.setFont(SevenSegNumFont);
        myGLCD.printNumI(profile.ki1,200, 240,3,'0');
        myGLCD.setColor(250, 180, 000);
        myGLCD.printNumI(profile.kd1,375, 240,3,'0');
      if (upSwitchState == HIGH && ( millis() - ms_button)>100)   {
        ms_button =  millis();
        profile.kd1 = profile.kd1 + 1;
        if (profile.kd1 >= 255)  profile.kd1 = 255;
        }
      if (downSwitchState == HIGH && ( millis() - ms_button)>100) {
        ms_button =  millis();
        profile.kd1 = profile.kd1 - 1;
        if (profile.kd1 <= 0)  profile.kd1 = 0;
        }
      if (okSwitchState == HIGH && !button_state && ( millis() - ms_button)>100)   {
        ms_button =  millis();
        button_state = true;
        }
      if (okSwitchState == LOW && button_state && ( millis() - ms_button)>100)     {        
        ms_button =  millis();
        button_state = false;
        SaveProfile();
        myGLCD.clrScr();
        reflowState = REFLOW_STATE_IDLE;
        }
      }
      break;
    case REFLOW_STATE_TABLE_SIZE:         {      // фиксируем размер стола
      if (profile.tableSize == 1)  digitalWrite(P1_PIN, HIGH);   
      if (profile.tableSize == 2)  { 
        digitalWrite(P1_PIN, HIGH);
        digitalWrite(P2_PIN, HIGH);
        }
      if (profile.tableSize == 3)  {
       digitalWrite(P1_PIN, HIGH);
       digitalWrite(P2_PIN, HIGH);
       digitalWrite(P3_PIN, HIGH);
       }
      // Serial.println("Мы тут ");
      reflowState = REFLOW_STATE_STEP_RAMP;
      }
      break;
    case REFLOW_STATE_BOTTOM_STEP_RAMP:   {      // рампа для нижнего нагревателя
      if ((currentMillis - previousMillis) > 1000/(profile.BottomRampRateStep * 0.1))  { //скорость роста температуры от 0.1с. до 3с.
        previousMillis = currentMillis;
        counter = counter + 1;
        setpointRamp = counter + startTemp;
        bottomMaxPwr = profile.min_pwr_BOTTOM + 2*counter;
        if (bottomMaxPwr >= profile.max_pwr_BOTTOM) bottomMaxPwr = profile.max_pwr_BOTTOM;
        myGLCD.setFont(BigFont);
        myGLCD.setColor(250, 180, 000);
        myGLCD.printNumI(setpointRamp,100, 227,3,'0');
        if (setpointRamp<profile.Setpoint2) bottomTemp = setpointRamp;
          else bottomTemp = profile.Setpoint2;
        if (Input2 >= profile.Setpoint2 )    {
          counter = 0;
          bottomTemp = profile.Setpoint2;     // ??
          updateScreen = true;
          reflowState = REFLOW_STATE_STEP_RAMP;        
          }
         }
      }  
      break;
    case REFLOW_STATE_STEP_RAMP:          {      // "Старт и процесс пайки", рост температуры с заданной скоростью
      if (updateScreen) {
        myGLCD.setFont(BigFontRus);
		    myGLCD.setColor(VGA_GREEN);
        myGLCD.textRus(F("НИЗ "),5, 300);
        //myGLCD.textRus(F("П- "),90, 300);
		    myGLCD.setFont(BigFont);
        myGLCD.print(F("P"),228, 232);
        myGLCD.print(F("I"),228, 250);
        myGLCD.print(F("D"),228, 268);
		    myGLCD.print(F("kD"),135, 268);
  		  myGLCD.print(F("P"),228, 119);
		    myGLCD.setColor(VGA_LIME);
        myGLCD.print(F("I"),228, 137);
		    myGLCD.setColor(VGA_GREEN);
        myGLCD.print(F("D"),228, 155);
		    myGLCD.print(F("kD"),135, 155);
        myGLCD.setFont(BigFont);
		    myGLCD.setColor(250, 180, 000);
        myGLCD.printNumI(profile.temperatureStep[editStep],100, 115,3,'0');
        myGLCD.printNumI(SP2,100, 227,3,'0');
        updateScreen = false;
        myGLCD.setFont(BigFontRus);
        myGLCD.setColor(0,255,50);
        if (profileName == 1) myGLCD.textRus(F("СНЯТИЕ БЕССВИНЕЦ "),190, 300);
        if (profileName == 2) myGLCD.textRus(F(" СНЯТИЕ СВИНЕЦ   "),190, 300);
        if (profileName == 3) myGLCD.textRus(F("УС-ВКА БЕССВИНЕЦ "),190, 300);
        if (profileName == 4) myGLCD.textRus(F("УС-ВКА СВИНЕЦ    "),190, 300);
        if (profileName == 5) myGLCD.textRus(F("НИЖНИЙ ПОДОГРЕВ  "),190, 300);
        startTemp = tc2;
        }       
      if (tc1 >= SP2-2 && !TopStart) {  //если температура низа вышла на уставку включаем верхний нагреватель  
        TopStart = true;
        myGLCD.setFont(BigFontRus);
        myGLCD.setColor(VGA_GREEN);
        myGLCD.textRus(F("ШАГ "),5, 300);
        myGLCD.textRus(F("П- "),90, 300);
        }
      if (TopStart == true)  {          // включен верхний нагреватель      
        if (flag == 0) {           //фиксируем стартовую температуру
          startTemp = tc1;
          flag = 1;
          }      
        if (startTemp > profile.temperatureStep[currentStep -1])   {  //устанавливаем нужный шаг, до которой нагрета плата  
          for (x=1; startTemp > profile.temperatureStep[currentStep - 1]; currentStep++)  {
            x++;
            }
          }      
        if (currentStep > x && flag == 1) {
          flag = 0;
          startTemp = profile.temperatureStep[currentStep - 2];        
          flag = 1;
          }
        myGLCD.setFont(BigFont);
        myGLCD.setColor(250, 180, 000);
        myGLCD.printNumI(currentStep,60, 300);
        //myGLCD.setFont(SevenSegNumFont);
        // myGLCD.printNumI(profile.temperatureStep[currentStep - 1],90, 120);
        
        //счётчик скорости роста температуры             
        if ((currentMillis - previousMillis) > 1000 / (profile.rampRateStep[currentStep - 1] * 0.1))  {  //скорость роста температуры от 0.1с. до 3с.     
          previousMillis = currentMillis;
          counter = counter + 1;
          setpointRamp = counter + startTemp;
          //myGLCD.setFont(BigFont);
          myGLCD.setColor(250, 180, 000);
          //myGLCD.printNumI(setpointRamp,420, 300,3,'0');
          myGLCD.printNumI(setpointRamp,100, 115,3,'0');
          Setpoint1 = setpointRamp;		
          }
       } //закрывам скобку
       else  {                          // тут переход на нижнюю рампу
        startTemp = tc2;
        // bottomMaxPwr = profile.min_pwr_BOTTOM;
        reflowState = REFLOW_STATE_BOTTOM_STEP_RAMP;
        } 
      if (setpointRamp >= profile.temperatureStep[currentStep - 1]) {   //если достигли нужной температуры      
        reflowState = REFLOW_STATE_STEP;
        }
      }
      break;     
    case REFLOW_STATE_STEP:               {
      Setpoint1 = profile.temperatureStep[currentStep - 1];	  
      if (Input1 >= profile.temperatureStep[currentStep - 1])    {
        counter = 0;
        reflowState = REFLOW_STATE_STEP_DWELL;        
        }
      }      
      break;
    case REFLOW_STATE_STEP_DWELL:         {       //считаем время перехода на следующий шаг
      if (currentMillis - previousMillis > 1000)    {        
        previousMillis = currentMillis;
        counter = counter + 1;
        myGLCD.setFont(BigFont);
        myGLCD.setColor(250, 180, 000);
        myGLCD.printNumI(counter,120, 300,2,'0');
        }
      if (counter == profile.dwellTimerStep[currentStep - 1]) { //если счётчик равен установленному времени       
        myGLCD.setFont(BigFont);
        myGLCD.setColor(VGA_RED);
        myGLCD.printNumI(counter,120, 300,2,'0');
        tone(buzzerPin, 1045, 500);  //звуковой сигнал
        counter = 0;
        setpointRamp = 0;
        
        if (profile.profileSteps == currentStep)  {   //если достигли последнего шага        
          currentStep = 1;
          x = 1;      //устанавливаем переменную в исходное состояние
          flag = 0;   //после завершения профиля сбрасываем флаг
          reflowState = REFLOW_STATE_COMPLETE;
          }
        else {    //если шаг не последний                  
          currentStep++; //переходим на следующий шаг          
          reflowState = REFLOW_STATE_STEP_RAMP;          
          }
        }
      }
      break;
    case REFLOW_STATE_COMPLETE:           {       //завершение пайки      
      digitalWrite(P1_PIN, LOW);
      digitalWrite(P2_PIN, LOW);
      digitalWrite(P3_PIN, LOW);
      digitalWrite(P4_PIN, LOW);
                  
      reflowStatus = REFLOW_STATUS_OFF;
      reflowState = REFLOW_STATE_IDLE;      
      updateScreen = true;
      TopStart=false;
      Xgr=2;
      XTgr=2;
      }
      break;
   }   // end switch(reflowState)
  if (reflowStatus == REFLOW_STATUS_ON)   {    //включение нагревателей   
    if (millis() > nextRead1)      {
      nextRead1 += SENSOR_SAMPLING_TIME;
      Input1 = Input1*0.8 + 0.2*(max6675_read_temp (thermoCLK,thermoCS,thermoDO));
      Input2 = Input2*0.8 + 0.2*(max6675_read_temp (thermoCLK2,thermoCS2,thermoDO2));
      Output2=Pid2(Input2,bottomTemp,profile.kp2,profile.ki2,profile.kd2);
      if (TopStart) Output1=Pid1(Input1,Setpoint1,profile.kp1,profile.ki1,profile.kd1);
      tc1 = Input1;
      tc2 = Input2;
      myGLCD.setColor(VGA_YELLOW);
  	  myGLCD.setFont(BigFontRus);
  	  myGLCD.printNumF((Input1 - Input_f1) * 1000 / (millis()-prev_millis),2,92,133,',',5);
  	  myGLCD.printNumF((Input2 - Input_f2) * 1000 / (millis()-prev_millis),2,92,245,',',5);
  	
  		prev_millis = millis();
  	  Input_f1 = Input1;
  	  Input_f2 = Input2;
  	  Icontrol();
           
      myGLCD.setColor(255,80,000);
  
  	  myGLCD.setFont(BigFontRus); 
  	  myGLCD.printNumI((Input2 - int(Input2))*100,443, 268, 2,'0');
  	  myGLCD.printNumI((Input1 - int(Input1))*100,443, 155, 2,'0');
  
  	  //--------------------------------
      myGLCD.setColor(VGA_YELLOW);
      //   myGLCD.textRus(F("НАГРЕВ"),235, 153);
      //   myGLCD.textRus(F("НАГРЕВ"),235, 266);

  	  myGLCD.printNumF(p2,2,241, 232,',',6,' ');
  	  myGLCD.printNumF(integra2,2,241, 250,',',6,' ');
  	  myGLCD.printNumF(d2,2,241, 268,',', 6,' ');
  	  myGLCD.printNumI(profile.kd1*10,170, 155,3,'0');
  	  myGLCD.printNumF(p1,2,241, 119,',',6,' ');
  	  myGLCD.printNumF(integra,2,241, 137,',',6,' ');
  	  myGLCD.printNumF(d1,2,241, 155,',', 6,' ');
  	  myGLCD.printNumI(profile.kd2*10,170, 268,3,'0');
  	  myGLCD.printNumF(Output2,1,365, 198,',',5,' ');
  	  myGLCD.printNumF(Output1,1,365, 84,',',5,' ');
  	  
  	  // графики---------------------------------------
  	  #ifndef no_pc
  	  sprintf (buf, "OK%03d%03d%03d%03d%03d\r\n", int(Output1), int(Output2), tc1, tc2,int(profileName)); // график ПК
      #endif	 

      if (Cgr == 4)   {      //скорость графика в условии	  
  		  myGLCD.setColor(0,0,0);
  		  myGLCD.drawLine(Xgr, 186, Xgr, 219);
    		myGLCD.drawLine(Xgr, 73, Xgr, 106);
  		  myGLCD.setColor(30,30,30);
  		  myGLCD.drawPixel(Xgr, 203);
  		  myGLCD.drawPixel(Xgr, 90);
  		  myGLCD.setColor(0,0,255);
  		  myGLCD.drawPixel(Xgr, 219-round(Output2 / 3));
  		  myGLCD.drawPixel(Xgr, 106-round(Output1 / 3));
  
  		  myGLCD.setColor(20,110,50);
  		  myGLCD.drawLine(Xgr+1, 186, Xgr+1, 219);
    		myGLCD.drawLine(Xgr+1, 73, Xgr+1, 106);
  
  		  Xgr++;
  		  if (Xgr >= 195)  {
		      Xgr = 2;
  		    myGLCD.setColor(0,0,0);

		      myGLCD.drawLine(195, 186, 195, 219);
		      myGLCD.drawLine(195, 73, 195, 106);
	        }		  
	      Cgr=0;
       }
      Cgr++;	  
      if (CTgr == 4)  {      //скорость графика в условии	  
  		  myGLCD.setColor(0,0,0);
    		myGLCD.drawLine(XTgr, 2, XTgr, 71);
  		  myGLCD.setColor(30,30,30);
  		  myGLCD.drawPixel(XTgr, 12);
  		  myGLCD.drawPixel(XTgr, 22);
  		  myGLCD.drawPixel(XTgr, 32);
  		  myGLCD.drawPixel(XTgr, 42);
  		  myGLCD.drawPixel(XTgr, 52);
  		  myGLCD.drawPixel(XTgr, 62);
  		  myGLCD.setColor(40,150,0);
  		  myGLCD.drawPixel(XTgr, 71-round((tc2-15) / 3.4));
  		  myGLCD.setColor(150,0,40);		  
  		  myGLCD.drawPixel(XTgr, 71-round((tc1-15) / 3.4));
  		  myGLCD.setColor(40,50,0);
    		myGLCD.drawLine(XTgr+1, 2, XTgr+1, 71);   
	      XTgr++;
	      if (XTgr >= 477) {		  
  			  XTgr = 2;
  	  		myGLCD.setColor(0,0,0);
  			  myGLCD.drawLine(477, 2, 477, 71);
  	  	  }		  
	      CTgr=0;
        } 
      CTgr++; 
      //------------------------------------------------- 
      if (isnan(Input1)) {
        myGLCD.setFont(BigFont);
        myGLCD.setColor(VGA_RED);
        myGLCD.print(F("ERORR"),360, 140);
        } 
       else {
          myGLCD.setFont(SevenSegNumFont);
          myGLCD.setColor(VGA_RED);
          myGLCD.printNumI(tc1,345, 120,3,'0');
          }
      if (isnan(Input2)) {
        myGLCD.setFont(BigFont);
        myGLCD.setColor(VGA_RED);
        myGLCD.print(F("ERORR"),360, 250);
        }
       else {
         myGLCD.setFont(SevenSegNumFont);
         myGLCD.setColor(VGA_RED);
         myGLCD.printNumI(tc2,345, 232,3,'0');
         }
   }            
    if (tc1 == SP2-5)   {
      digitalWrite(P4_PIN, HIGH);
      tone(buzzerPin, 1045, 500);  //звуковой сигнал
      } 
    if (tc1 >= 250)     {
      digitalWrite(P1_PIN, LOW);
      digitalWrite(P2_PIN, LOW);
      digitalWrite(P3_PIN, LOW);
      digitalWrite(P4_PIN, LOW);
      tone(buzzerPin, 1045, 400);  //звуковой сигнал
     
      reflowStatus = REFLOW_STATUS_OFF;
      reflowState = REFLOW_STATE_IDLE;    
      updateScreen = true;
      }       
    if (!TopStart) Output1=0;    
    }
    else  {
      digitalWrite(RelayPin1, LOW);
      digitalWrite(RelayPin2, LOW);
      }
 } // end loop     
void Dimming()  {
  OutPWR_TOP();
  OutPWR_BOTTOM();
 #ifndef no_pc
  if (Secs >= 100)
    {
    Serial.println(buf);
	  Secs=0;
    } 
    else Secs++;
  #endif
}
void Icontrol() {
	if (Hselect==0) {
    if (upSwitchState == HIGH && ( millis() - ms_button)>100)   {
       ms_button =  millis();
       integra++;
       if (integra >= 100)  integra = 100;
       }
    if (downSwitchState == HIGH && ( millis() - ms_button)>100) {
      ms_button =  millis();
      integra--;
      if (integra <= 0) integra = 0;        
      }
    } 
  if (Hselect==1) {
    if (upSwitchState == HIGH && ( millis() - ms_button)>100)   {
      ms_button =  millis();
      integra2++;
      if (integra2 >= 100) integra2 = 100;
      }
    if (downSwitchState == HIGH && ( millis() - ms_button)>100) {
      ms_button =  millis();
      integra2--;
      if (integra2 <= 0) integra2 = 0;        
      }
    }
  if (Hselect==2) {
    if (upSwitchState == HIGH && ( millis() - ms_button)>100)   {
      if (profile.kd1 < 254)  {
        ms_button =  millis();
        profile.kd1++;        
        }
      }
    if (downSwitchState == HIGH && ( millis() - ms_button)>100) {
      if (profile.kd1 > 0)    {
        ms_button =  millis();
        profile.kd1--;        
        }
      }           
    }
  if (Hselect==3) {
     if (upSwitchState == HIGH && ( millis() - ms_button)>100)   {
      if (profile.kd2 < 254)  {
        ms_button =  millis();
        profile.kd2++;
        }
      }
     if (downSwitchState == HIGH && ( millis() - ms_button)>100) {
       if (profile.kd2 > 0)  {
        ms_button =  millis();
        profile.kd2--;
        }
       }          
    }	  
	if (okSwitchState == HIGH)  {        
    myGLCD.setFont(BigFont);     // button_state = false;      
    if (Hselect==0)		{
		  myGLCD.setColor(VGA_GREEN);
      myGLCD.print(F("I "),228, 137);
	  	myGLCD.setColor(VGA_LIME);        
	  	myGLCD.print(F("I "),228, 250);
      }		
    if (Hselect==1)		{
  		myGLCD.setColor(VGA_GREEN);
      myGLCD.print(F("I "),228, 250);
  		myGLCD.setColor(VGA_LIME);        
  		myGLCD.print(F("kD "),135, 155);  		  
      }
    if (Hselect==2)   {
  		myGLCD.setColor(VGA_GREEN);
      myGLCD.print(F("kD "),135, 155);
  		myGLCD.setColor(VGA_LIME);        
  		myGLCD.print(F("kD "),135, 268);		    
      }
    if (Hselect>=3)		{
  		myGLCD.setColor(VGA_LIME);
      myGLCD.print(F("I "),228, 137);
  		myGLCD.setColor(VGA_GREEN);       
  		myGLCD.print(F("kD "),135, 268);		    
      }
    Hselect++;
		if (Hselect==4) Hselect=0;
   }
	}
void OutPWR_TOP()     { 
       reg1 = Output1 + er1; //pwr- задание выходной мощности в %,в текущем шаге профиля, er- ошибка округления   
        if (reg1 < 50){
          out1 = LOW;
          er1 = reg1; // reg- переменная для расчетов
          }
        else {
          out1 = HIGH;
          er1 = reg1-100;
        }
       digitalWrite(RelayPin1,out1);//пин через который осуществляется дискретное управление   
       }      
void OutPWR_BOTTOM()  {
       reg2 = Output2 + er2; //pwr- задание выходной мощности в %, er- ошибка округления
        if (reg2 < 50){
          out2 = LOW;
          er2 = reg2; // reg- переменная для расчетов
        }
        else {
          out2 = HIGH;
          er2 = reg2-100;
        }
       digitalWrite(RelayPin2,out2);//пин через который осуществляется дискретное управление
       }       
byte Pid1(double temp, byte ust, byte kP, byte kI, byte kd)   {
        byte out = 0;
        static float ed = 0;
        e1 = (ust - temp); //ошибка регулирования
        p1 =  (kP * e1); //П составляющая
        integra = (integra < i_min) ? i_min : (integra > i_max) ? i_max : integra + (kI * e1)/1000.0; //И составляющая
        d1 = kd * (e1 - ed); //Д составляющая
        ed = e1;
        out = (p1 + integra + d1 < profile.min_pwr_TOPStep[currentStep - 1]) ? profile.min_pwr_TOPStep[currentStep - 1] : (p1 + integra + d1 > profile.max_pwr_TOPStep[currentStep - 1]) ? profile.max_pwr_TOPStep[currentStep - 1] : p1 + integra + d1;
        return out;
 }
byte Pid2(double temp, double ust, byte kP, byte kI, byte kd) {
        byte out = 0;
        static float ed = 0;
        e2 = (ust - temp);   //ошибка регулирования
        p2 =  (kP * e2);     //П составляющая
        integra2 = (integra2 < i_min) ? i_min : (integra2 > i_max) ? i_max : integra2 + (kI * e2)/1000.0; //И составляющая
        d2 = kd * (e2 - ed); //Д составляющая
        ed = e2;
        out = (p2 + integra2 + d2 < profile.min_pwr_BOTTOM) ? profile.min_pwr_BOTTOM : (p2 + integra2 + d2 > bottomMaxPwr) ? bottomMaxPwr : p2 + integra2 + d2;
        return out;
 }
double max6675_read_temp (int ck, int cs, int so)  {
   char i; 
   int tmp = 0; 
   digitalWrite(cs, LOW);//cs = 0;                            // Stop a conversion in progress 
   asm volatile
    (
     " nop"        "\n\t"
    );
   for (i=15;i>=0;i--)
    {  digitalWrite(ck, HIGH);
      asm volatile
    (
     " nop"        "\n\t"
    );
      if( digitalRead(so))
      tmp|=(1<<i);
    
  
      digitalWrite(ck, LOW);
    asm volatile
    (
     " nop"        "\n\t"
    );
    } 
   digitalWrite(cs, HIGH);
   if (tmp & 0x4) {
     return NAN; 
   } else 
   return ((tmp>>3))*0.25;
 }
// end 
